> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve a payment run

GET https://rest.test.zuora.com/object-query/payment-runs/{key}

Retrieve the details of a specific Payment Run object.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/object-query/object-queries/query-payment-run-by-key

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `key` (string, required) — Object ID or Number.

### Query parameters

- `pageSize` (integer, optional, default: 10) — The maximum number of results to return in a single page. If the specified `pageSize` is less than 1 or greater than 99, Zuora will return a 400 error.
- `cursor` (string, optional) — A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with `next_page=W3sib3JkZXJ=`, your subsequent call can include `cursor=W3sib3JkZXJ=` in order to fetch the next page of the list.
- `sort[]` (list of string, optional) — A case-insensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. `accountnumber.ASC`) or descending (e.g. `accountnumber.DESC`). You cannot sort on properties in arrays. If the array-type properties are specified for the `sort[]` parameter, they are ignored.
- `expand[]` (list of string, optional) — Allows you to expand responses by including related object information in a single call. The Payment Run object does not support expanding any related objects.
- `filter[]` (list of string, optional) — A case-insensitive filter on the list.
- `fields[]` (list of string, optional) — A case-insensitive query parameter that allows you to specify which fields are returned in the response.
- `includeNullFields` (boolean, optional, default: false) — Specifies whether to include fields with the `null` value in the response. - If set to `true`, all fields will be returned in the response, including those with the `null` value. - If set to `false`, only fields with non-null values will be returned.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `id` (string, optional) — The unique identifier of the payment run.
- `createdById` (string, optional) — The unique identifier of the user who created the payment run.
- `createdDate` (datetime, optional) — The time that the payment run gets created in the system, in the `YYYY-MM-DD HH:MM:SS` format.
- `updatedById` (string, optional) — The unique identifier of the user who last updated the payment run.
- `updatedDate` (datetime, optional) — The time that the payment run gets updated in the system, in the `YYYY-MM-DD HH:MM:SS` format.
- `endDate` (string, optional) — The end date of the payment run.
- `executedDate` (datetime, optional) — The date and time when the payment run is executed, in `yyyy-mm-dd hh:mm:ss` format. For example, 2024-03-01 11:30:37.
- `numberOfCreditBalanceAdjustments` (integer, optional) — **Note:** This field is only available if you have the Credit Balance feature enabled. The number of credit balance adjustments that are successfully processed in the payment run.
- `numberOfErrors` (integer, optional) — The number of payments with the status of `Error` and `Processing`.
- `numberOfInvoices` (integer, optional) — **Note:** This field is only available if you have the Invoice Settlement feature enabled. The total number of invoices that are picked up for processing in the payment run.
- `numberOfPayments` (integer, optional) — The number of payments that are successfully processed in the payment run.
- `numberOfUnprocessed` (integer, optional) — The number of billing documents with remaining positive balances after the payment run is completed.
- `paymentRunNumber` (string, optional) — Number of the payment run.
- `status` (enum, optional) — The status of the created payment run.
  - Allowed values: `Pending`, `Processing`, `Completed`, `Error`, `Canceled`
- `targetDate` (date, optional) — The target date used to determine which receivables to be collected in the payment run.
- `applyCreditBalance` (boolean, optional) — Whether to apply credit balances in the payment run. This field is only available when you have Invoice Settlement feature disabled.
- `consolidatedPayment` (boolean, optional) — **Note:** The **Process Electronic Payment** permission also needs to be allowed for a Manage Payment Runs role to work. See [Payments Roles](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/A_Administrator_Settings/User_Roles/e_Payments_Roles) for more information. Whether to process a single payment for all receivables that are due on an account.
- `processPaymentWithClosedPM` (boolean, optional) — Whether to process payments even if the default payment method is closed. **Note:** The **Process Electronic Payment** permission also needs to be allowed for a Manage Payment Runs role to work. See [Payments Roles](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/A_Administrator_Settings/User_Roles/e_Payments_Roles) for more information.
- `collectPayment` (boolean, optional) — Whether to process electronic payments during the execution of payment runs.
- `autoApplyCreditMemo` (boolean, optional) — Whether to automatically apply a posted credit memo to one or more receivables in the payment run. **Note:** This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
- `autoApplyUnappliedPayment` (boolean, optional) — Whether to automatically apply unapplied payments to one or more receivables in the payment run. **Note:** This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
- `numberOfCreditMemos` (integer, optional) — The total number of credit memos that are successfully processed in the payment run. **Note:** This field is only available if you have the Invoice Settlement feature enabled.
- `numberOfDebitMemos` (integer, optional) — The total number of debit memos that are picked up for processing in the payment run. **Note:** This field is only available if you have the Invoice Settlement feature enabled.
- `numberOfDebitMemosUnprocessed` (integer, optional) — The total number of debit memos that are not processed in the payment run. **Note:** This field is only available if you have the Invoice Settlement feature enabled.
- `numberofUnappliedPayments` (integer, optional) — The number of unapplied payments that are successfully processed in the payment run. **Note:** This field is only available if you have the Invoice Settlement feature enabled.
- `totalExecutionTime` (long, optional) — The total time taken to execute the payment run in milliseconds.
- `errorMessage` (string, optional) — The detailed information of the error response.
- `runDate` (date, optional) — The date and time when the scheduled payment run is to be executed for collecting payments.
- `nextRunOn` (date, optional) — The date when the next payment run is scheduled to run.
- `repeatType` (enum, optional) — The repeat type of the payment run.
  - Allowed values: `None`, `Daily`, `Weekly`, `Monthly`
- `repeatFrom` (string, optional) — The start date of the scheduled payment run.
- `repeatTo` (string, optional) — The end date of of the scheduled payment run.
- `runTime` (integer, optional) — The scheduled run time (hour) of day.
- `timeZone` (string, optional) — Timezone of the scheduled payment run.
- `monthlyOnDay` (string, optional) — The repeat day in a month.
- `weeklyOnDay` (enum, optional) — The repeat day in a week. This field is required if you set `repeatType` field to `Weekly`.
  - Allowed values: `Mon`, `Tue`, `Wed`, `Thu`, `Fri`, `Sat`, `Sun`
- `accountId` (string, optional) — The ID of the customer account associated with the payment run.
- `batch` (string, optional) — The alias name given to a batch.
- `billingCycleDay` (string, optional) — The billing cycle day (BCD), the day of the month when a bill run generates invoices for the account.
- `currency` (string, optional) — A currency defined in the web-based UI administrative settings.
- `paymentGatewayId` (string, optional, nullable) — The ID of the gateway instance that processes the payment.
- `billingRunId` (string, optional) — The unique identifier of the billing run that the payment run is associated with.

## Errors

### 500 Internal Server Error

Internal server error

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

### 400 Client Request Error

Invalid input

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

## Types

### CommonOqErrorResponseReasonsItems

- `code` (integer, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Response**

```json
{
  "id": "8ad08d29889f71e901889fa868cf70ef",
  "createdById": "2c92c0f972a852360172bbe22ac551b6",
  "createdDate": "2023-06-09T03:16:33-07:00",
  "updatedById": "2c92c0f972a852360172bbe22ac551b6",
  "updatedDate": "2023-06-09T03:16:35-07:00",
  "endDate": "2023-06-09T03:16:35-07:00",
  "executedDate": "2023-06-09T03:16:35-07:00",
  "numberOfCreditBalanceAdjustments": 0,
  "numberOfErrors": 0,
  "numberOfInvoices": 0,
  "numberOfPayments": 0,
  "numberOfUnprocessed": 0,
  "paymentRunNumber": "PR-00000002",
  "status": "Completed",
  "targetDate": "2022-07-01",
  "applyCreditBalance": false,
  "consolidatedPayment": false,
  "processPaymentWithClosedPM": false,
  "collectPayment": true,
  "autoApplyCreditMemo": false,
  "autoApplyUnappliedPayment": false,
  "numberOfCreditMemos": 0,
  "numberOfDebitMemos": 0,
  "numberOfDebitMemosUnprocessed": 0,
  "numberofUnappliedPayments": 0,
  "totalExecutionTime": 535,
  "runDate": "2022-07-01",
  "currency": "1",
  "billingRunId": "BR-00000018"
}
```

**SDK Code**

```python Object Queries_queryPaymentRunByKey_example
import requests

url = "https://rest.test.zuora.com/object-query/payment-runs/key"

querystring = {"fields[]":"[\"id,createddate\"]"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Object Queries_queryPaymentRunByKey_example
const url = 'https://rest.test.zuora.com/object-query/payment-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Object Queries_queryPaymentRunByKey_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/object-query/payment-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Object Queries_queryPaymentRunByKey_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/object-query/payment-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Object Queries_queryPaymentRunByKey_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/object-query/payment-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Object Queries_queryPaymentRunByKey_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/object-query/payment-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Object Queries_queryPaymentRunByKey_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/object-query/payment-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Object Queries_queryPaymentRunByKey_example
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/object-query/payment-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```